﻿using Lab4.Interfaces;
using Lab4.Plugins.Implementations;
using Microsoft.Extensions.DependencyInjection;

namespace Lab4.Plugins.Extensions
{
    public static class DiExtensions
    {
        public static IServiceCollection AddScopes(
            this IServiceCollection services)
        {
            services.AddScoped<PluginsConvention>();

            services.AddScoped<Func<Type, IPluginsConvention>>(sp
                => (type) => (sp.GetRequiredService(type) as IPluginsConvention)!);

            return services;
        }
    }
}
